#include <stdio.h>
#include <reg51.h>


unsigned char calc_checksum (
  unsigned char *start_addr,
  unsigned int len)
{
unsigned char checksum = 0;

for (; len > 0; len--, start_addr++)
  {
  checksum += *start_addr;
  }

return (checksum);
}

/*---------------------------------------------------------
Checksum RANGE = 0x0000-0x3FFE
Checksum BYTE  = 0x3FFF
---------------------------------------------------------*/
void main (void)
{
unsigned char checksum;

    SCON  = 0x50;		        /* SCON: mode 1, 8-bit UART, enable rcvr      */
    TMOD |= 0x20;               /* TMOD: timer 1, mode 2, 8-bit reload        */
    TH1   = 221;                /* TH1:  reload value for 1200 baud @ 16MHz   */
    TR1   = 1;                  /* TR1:  timer 1 run                          */
    TI    = 1;                  /* TI:   set TI to send first char of UART    */

checksum = calc_checksum ((unsigned char code *) 0, 0x4000);

if (checksum != 0x80)
  {
  /*** CHECKSUM FAILED ***/
  puts ("Checksum Failed\n");
  }
else
  {
  /*** CHECKSUM WORKED ***/
  puts ("Checksum Succeeded\n");
  }

while (1);
}

